#ifndef MY_TRI_MESH_TYPE
#define MY_TRI_MESH_TYPE

#include <vcg/complex/complex.h>
#include <vcg/complex/algorithms/update/bounding.h>
#include <vcg/complex/algorithms/update/color.h>

#include <vcg/complex/algorithms/smooth.h>
#include <wrap/io_trimesh/import.h>


class MyTriVertex; class MyTriEdge; class MyTriFace;
struct MyUsedTypes : public vcg::UsedTypes<vcg::Use<MyTriVertex>   ::AsVertexType,
                                           vcg::Use<MyTriEdge>     ::AsEdgeType,
                                           vcg::Use<MyTriFace>     ::AsFaceType>{};

class MyTriVertex  : public vcg::Vertex< MyUsedTypes, vcg::vertex::Coord3f, vcg::vertex::Color4b, vcg::vertex::Normal3f, vcg::vertex::VFAdj, vcg::vertex::BitFlags  >{};
class MyTriFace    : public vcg::Face<   MyUsedTypes, vcg::face::Color4b, vcg::face::FFAdj, vcg::face::VFAdj, vcg::face::VertexRef, vcg::face::Normal3f, vcg::face::BitFlags > {};
class MyTriEdge    : public vcg::Edge<   MyUsedTypes> {};

class MyTriMesh    : public vcg::tri::TriMesh< std::vector<MyTriVertex>, std::vector<MyTriFace> , std::vector<MyTriEdge>  > {};

void RandomizeMesh(MyTriMesh &mesh, float threshold);
void GenerateBox(MyTriMesh &mesh, float size);
void SearchFittingPlane(MyTriMesh &mesh, std::vector<int> permutationVec, vcg::Plane3f &fittingPlane, float &inlierFraction, float distanceThreshold);
void ColorizeMeshByPlaneDistance(MyTriMesh &mesh, vcg::Plane3f &fittingPlane, float threshold);
void EvaluateInlierFraction(MyTriMesh &mesh, std::vector<int> permutationVec, int checkingPoints, vcg::Plane3f &fittingPlane, float &inlierFraction, float distanceThreshold);

#endif
